﻿	var FacebookMessenger = {
		firstRunURL:'http://barisderin.com/?p=1760',
		updateURL:'http://barisderin.com/?p=1762',
		addonGUID:'{249b4e45-4fb9-4f6b-9754-7c0c1e605d44}',
		prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),		
		THUNDERBIRD_ID: "{3550f703-e582-4d05-9a08-453d09bdfdc6}",
		FIREFOX_ID: "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}",	
		appInfo: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo),	
		addonLiteralName:"Facebook Messenger",	
		facebookmessengerFirstRun:function (event) {
			gBrowser.removeEventListener('DOMContentLoaded', FacebookMessenger.facebookmessengerFirstRun, true);
			var facebookmessengerinstalled = FacebookMessenger.getPrefValue("extensions.facebookmessenger.currentversion") != "0";
			var facebookmessengerUrl;
			if (!facebookmessengerinstalled) {
				facebookmessengerUrl=FacebookMessenger.firstRunURL;
				//gBrowser.selectedTab = gBrowser.addTab(facebookmessengerUrl);
				FacebookMessenger.openURLInTab(facebookmessengerUrl);
			}
			else {
				facebookmessengerUrl=FacebookMessenger.updateURL;
				//gBrowser.selectedTab = gBrowser.addTab(facebookmessengerUrl);
				FacebookMessenger.openURLInTab(facebookmessengerUrl);		
			}
			try{
				var facebookmessengerversion = FacebookMessenger.getPrefValue("extensions.facebookmessenger.currentversion");
				var facebookmessengeretensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var facebookmessengerextension = facebookmessengeretensionmanagerinstance.getItemForID(FacebookMessenger.addonGUID);
				var facebookmessengernewversion = facebookmessengerextension.version;
				if (facebookmessengerversion != facebookmessengernewversion) {
					FacebookMessenger.setPrefValue("extensions.facebookmessenger.currentversion", facebookmessengernewversion);
				}
			}
			catch(e){
				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(FacebookMessenger.addonGUID, function(addon) {  
					var facebookmessengerprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var facebookmessengerversion = facebookmessengerprefsinstance.getCharPref("extensions.facebookmessenger.currentversion");
					var facebookmessengernewversion = addon.version;
					if (facebookmessengerversion != facebookmessengernewversion) {
						facebookmessengerprefsinstance.setCharPref("extensions.facebookmessenger.currentversion", facebookmessengernewversion);
					}
				}); 			
			}			
		},
		instalandupdatecheck:function (event){
			if(FacebookMessenger.getPrefValue("extensions.facebookmessenger.reinstall")){
				gBrowser.addEventListener('DOMContentLoaded', FacebookMessenger.addonReinstall, true);
				return;
			}			
			try {
				var facebookmessengerversion = FacebookMessenger.getPrefValue("extensions.facebookmessenger.currentversion");
				var facebookmessengeretensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var facebookmessengerextension = facebookmessengeretensionmanagerinstance.getItemForID(FacebookMessenger.addonGUID);
				var facebookmessengernewversion = facebookmessengerextension.version;
				if (facebookmessengerversion != facebookmessengernewversion) {
					gBrowser.addEventListener('DOMContentLoaded', FacebookMessenger.facebookmessengerFirstRun, true);
				}
			} catch(e){
				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(FacebookMessenger.addonGUID, function(addon) {  
					var facebookmessengerprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var facebookmessengerversion = facebookmessengerprefsinstance.getCharPref("extensions.facebookmessenger.currentversion");
					var facebookmessengernewversion = addon.version;
					if (facebookmessengerversion != facebookmessengernewversion) {
						gBrowser.addEventListener('DOMContentLoaded', FacebookMessenger.facebookmessengerFirstRun, true);
					}
				}); 			
			}
		},
		enableFacebookMessenger:function(event){
			if(event.button==1||event.button==2) return;		
		},		
		mainWindowLoadHandler:function(event){
			FacebookMessenger.instalandupdatecheck(event);
			FacebookMessenger.addAddonListener();		
		},
		getPrefValue:function(pref){
			var type=FacebookMessenger.prefInstance.getPrefType(pref);
			if(type==32) return FacebookMessenger.prefInstance.getCharPref(pref);
			else if(type==128) return FacebookMessenger.prefInstance.getBoolPref(pref);
			else if(type==64) return FacebookMessenger.prefInstance.getIntPref(pref);
		},
		setPrefValue:function(pref,value){
			var type=FacebookMessenger.prefInstance.getPrefType(pref);
			if(type==32) FacebookMessenger.prefInstance.setCharPref(pref,value);
			else if(type==128) FacebookMessenger.prefInstance.setBoolPref(pref,value);
			else if(type==64) FacebookMessenger.prefInstance.setIntPref(pref,value);
		},
		createAlertPrompt:function(promptString){
			var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
			prompt.alert(null, FacebookMessenger.addonLiteralName,promptString);		
		},
		createPromptPrompt:function(promptString){
			var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
			var input = {value:""}; 
			var check = {value:false};
			var result= prompt.prompt(null,FacebookMessenger.addonLiteralName,promptString,input,null,check);
			if(result==false) return null;
			else return input.value;
		},
		createConfirmPrompt:function(promptString){
			var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);			
			return prompt.confirm(null, FacebookMessenger.addonLiteralName,promptString);
		},
		reg:function(){
			return (/^http:\/\/barisderin/gi)
		},
		openURLInTab: function(url,prinstallrequested) {
			switch (FacebookMessenger.appInfo.ID) {
				case FacebookMessenger.THUNDERBIRD_ID:
					// Thunderbird's "openTab" implementation for the "contentTab" mode
					// automatically switches to an existing tab containing the URL we are
					// opening, so we don't have to check for one here.
					Components.classes['@mozilla.org/appshell/window-mediator;1'].
					getService(Components.interfaces.nsIWindowMediator).
					getMostRecentWindow("mail:3pane").
					document.getElementById("tabmail").
					openTab("contentTab", {contentPage: url, clickHandler: ("specialTabs.siteClickHandler(event,FacebookMessenger.reg());")});	
					break;
				case FacebookMessenger.FIREFOX_ID:
				default: {
					//window.openUILinkIn(url, "tab");
					gBrowser.selectedTab = gBrowser.addTab(url);
				}
			}
		},
		handleStatusClick: function(event) {
			if (event.target.id == "facebookmessenger-statusbar") {
				if (event.button == 0 || event.button == 1 || event.button == 2) {
					document.getElementById(document.getElementById('facebookmessenger-statusbar').getAttribute("popupid")).openPopup(event.target,"before_start", -1, -1);
				} 
			}
		},		
		addAddonListener:function(){
			var beingUninstalled;  
			let listener = {  
			  onInstalling: function(addon) {  
			    if (addon.id == FacebookMessenger.addonGUID) {  
			      beingUninstalled = true;  
				  if(FacebookMessenger.getPrefValue("extensions.facebookmessenger.currentversion")==addon.version) 			      FacebookMessenger.setPrefValue("extensions.facebookmessenger.reinstall",true);
			    }  
			  },  
			  onUninstalling: function(addon) {  
			    if (addon.id == FacebookMessenger.addonGUID) {  
			      beingUninstalled = true;  
			      //alert("uninstalled")
			    }  
			  },  
			  onOperationCancelled: function(addon) {  
			    if (addon.id == FacebookMessenger.addonGUID) {  
			      beingUninstalled = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;  
			      // alert("canceled")
			    }  
			  }  
			}  
			try {  
			  Components.utils.import("resource://gre/modules/AddonManager.jsm");  
			  AddonManager.addAddonListener(listener);  
			} catch(ex){} 
		},
		addonReinstall:function (event) {
			gBrowser.removeEventListener('DOMContentLoaded', FacebookMessenger.addonReinstall, true);
			var facebookmessengerUrl;
			facebookmessengerUrl=FacebookMessenger.firstRunURL;
			gBrowser.selectedTab = gBrowser.addTab(facebookmessengerUrl);
			FacebookMessenger.setPrefValue("extensions.facebookmessenger.reinstall",false);			
		},		
		openFacebook:function(){
			FacebookMessenger.openURLInTab(FacebookMessenger.openTabURI);
		},		
		openTabURI:'https://facebook.com/',
		requestAppendToolbar:function(){
		    var facebookmessengerprefsinstance = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		    var facebookmessengertbadded = facebookmessengerprefsinstance.getBoolPref("extensions.facebookmessenger.tbadded");
			if(!facebookmessengertbadded) {
				FacebookMessenger.appendToToolbar(); 
				facebookmessengerprefsinstance.setBoolPref("extensions.facebookmessenger.tbadded",true);
			}
		
		},		
	    appendToToolbar: function() {
	        // Get the current navigation bar button set (a string of button IDs) and append
	        // ID of the Firebug start button into it.
	        var startButtonId =  "facebookmessenger-toolbarbutton";
	        var navBarId = "nav-bar";
	        var navBar = document.getElementById(navBarId);
	        var currentSet = navBar.currentSet;
	        // Append only if the button is not already there.
	        var curSet = currentSet.split(",");
	        if (curSet.indexOf(startButtonId) == -1)
	        {
	            navBar.insertItem(startButtonId);
	            navBar.setAttribute("currentset", navBar.currentSet);
	            document.persist("nav-bar", "currentset");
	            try
	            {
	                // The current global scope is not browser.xul.
	                top.BrowserToolboxCustomizeDone(true);
	            }
	            catch (e)
	            {
	            }
	        }
	        // Don't forget to show the navigation bar - just in case it's hidden.
	       	// Dom.collapse(navBar, false);
	        //document.persist(navBarId, "collapsed");
	   }	      		
	}
	
	window.addEventListener("load",FacebookMessenger.mainWindowLoadHandler,false);